.286 
.model tiny 

code segment
assume cs:code
org 100h
prog:
jmp init
old_irq9_handler dd ?
old_2f_handler dd ?
old_es dw ?
my_irq9_handler proc
     pushf 
     call cs:[old_irq9_handler]

     pusha 
     push ds
     push es

     push 0040h 
     pop ds

     mov di, word ptr ds:0001Ah 
     cmp di ,word ptr ds:0001Ch
     je exit 
     
     mov ax, word ptr [di]
     cmp ah, 22h
     jne exit

     mov al, byte ptr ds:0017h
     test al, 03h 
     jz exit

     call Delete

exit:
     pop es
     pop ds
     popa 
     iret
my_irq9_handler endp

my_2f_handler proc
   cmp al, 0
   cli 
   jne call_old 
   cmp ah, 0F2h
   jne call_old
   
   mov al,0FFh
   sti
   iret
call_old:
    sti
    call cs:[old_2f_handler]
my_2f_handler endp

Delete proc
   push ax
   push ds
   mov dx, offset old_irq9_handler
   mov ax, offset old_irq9_handler+2
   mov ds, ax
   
   mov ah,25h
   mov al,09h
   int 21h 
   pop ds

   mov dx, offset old_2f_handler
   mov ax, old_2f_handler+2
   mov ds,ax
   mov ax,252Fh
   int 21h   

   pop ds
   pop ax
   ret
Delete endp 
end_res:

installed_str db  'TSR installed',0Dh,0Ah,'$'

init:
   mov ax, code
  ; mov cs, ax
   mov ds, ax 

   mov ah, 0F2h
   mov al, 00
   int 2fh 

   cmp al,0FFh
   je installed

   mov ah, 35h
   mov al, 09h
   int 21h 

   mov old_irq9_handler, bx
   mov old_irq9_handler+2, es

   mov ah, 25h
   mov al, 09h
   mov dx, offset my_irq9_handler
   int 21h

   mov ah, 35h
   mov al, 2Fh
   int 21h

   mov old_2f_handler, bx
   mov old_2f_handler+2, es

   mov ah, 25h
   mov al, 2Fh
   mov dx, offset my_2f_handler 
   int 21h

   mov dx,offset end_res+1 
   mov ax, 03100h
   int 21h

installed:

    mov ah, 9 
    mov dx,offset installed_str
    int 21h

exit_main:
    mov ax,04c00h
    int 21h
code ends
end prog 
