#ifndef __SORTFACTORY_H__
#define __SORTFACTORY_H__
#include "Sorter.h"
#include "QuickSort.h"
#include "RadixSort.h"

enum TypeOfSort
{
	QuickSort, 
	RadixSort
};

class SorterFactory
{
private:
	static QuickSorter &getQuickSorter();
	static RadixSorter &getRadixSorter();
	SorterFactory(){};
	SorterFactory(SorterFactory &rhs){};
	SorterFactory &operator=(SorterFactory &rhs){};
public:
	static Sorter &getInstance(TypeOfSort type);
};

#endif